var imageDomain = settings.courseImageDomain;
var extension = settings.courseImageExtension;

template.helper('getImageUrl', function(productId){
	var t = $.format.date(new Date(), "yyyyMMddHHmm");
	var imageUrl = imageDomain + productId + extension + "?t=" + t;
	return imageUrl;
});

var thumbnailSize = settings.courseThumbnailSize;
template.helper('getThumbnailUrl', function(productId){
	var imageUrl = productId + "-" + thumbnailSize + extension;
	return imageUrl;
});

template.helper('stopSaleDateDiff', function(dateTime){
	var ssd = $.format.date(dateTime, "yyyy-MM-dd HH:mm:ss");
	var diff = new DateDiff(new Date(ssd), new Date());
	
	var result;
	var diffDays = parseInt(diff.days());
	if(diffDays > 0){
		result = diffDays + "天";
	}else{
		var diffHours = parseInt(diff.hours());
		if(diffHours > 0){
			result = diffHours + "小时";
		}else{
			var diffMinutes = parseInt(diff.minutes());
			if(diffMinutes > 0){
				result = diffMinutes + "分钟";
			}else{
				result = "已停售";
			}
		}
	}
	
	return result;
});

template.helper('countDownDateDiff', function(dateTime){
	var ssd = $.format.date(dateTime, "yyyy-MM-dd HH:mm:ss");
	var diff = new DateDiff(new Date(ssd), new Date());
	
	var result;
	var diffDays = parseInt(diff.days());
	if(diffDays > 0){
		result = diffDays + "天";
	}else{
		var diffHours = parseInt(diff.hours());
		if(diffHours > 0){
			result = diffHours + "小时";
		}else{
			result = "已上课";
		}
	}
	
	return result;
});

template.helper('numberAdd', function(n1, n2){
	return Number(n1) + Number(n2);
});

template.helper('numberSub', function(n1, n2){
	return Number(n1) - Number(n2);
});

template.helper('dateFormat', function(dateTime){
	return $.format.date(dateTime, "yyyy-MM-dd HH:mm");
});

template.helper('priceFormat', function(price){
	return toDecimal(price);
});

var imageLoadErrorMap = {};
function loadImg(defaultImg) {
	[].forEach.call(document.querySelectorAll("img[data-src]"), function(img) {
		var fileName = img.getAttribute("data-src");
		img.setAttribute('crossOrigin', 'anonymous');
		img.removeAttribute("data-src");
		
		getItem(fileName, function(value) {
			if(value == null) {
				var ts = $.format.date(new Date(), "yyyyMMddHHmm");
				var imgSrc = imageDomain + fileName + "?ts=" + ts;
				
				img.setAttribute("src", imgSrc);
				img.onload = function(){
					if(imageLoadErrorMap[fileName] !== true){
						var dataURL = getBase64Image(img, 2);
						lfSetItem(fileName, dataURL);
					}
				};
				img.onerror = function(){
					imageLoadErrorMap[fileName] = true;
					img.src = defaultImg;
				}
			} else {
				img.setAttribute("src", value);
			}
		});
	});
}
