localforage.config({
    name: 'QINGYUN'
});

function lfSetItem(key, value){
	localforage.setItem(key, value).then(function (value){
		if(settings.debugMode === true){
	    	console.log("setItem [" + key + "] successed.");
		}
	}).catch(function(err){
	    console.log(err);
	});
}

function lfGetItem(key, callback){
	localforage.getItem(key).then(function(value){
		if(settings.debugMode === true){
			console.log("getItem [" + key + "] successed.");
		}
	   	callback(value);
	}).catch(function(err){
	    console.log(err);
	    callback("ERROR");
	});
}

function lfRemoveItem(key, callback){
	localforage.removeItem(key).then(function(){
	    callback(true);
	}).catch(function(err){
	    console.log(err);
	    callback(false);
	});
}

function getItem(name, callback){
	lfGetItem(name, function(result){
		if(result == "ERROR"){
			result = null;
		}
		
		if(callback){
			callback(result);
		}
	});
}

function removeItem(name, callback){
	lfRemoveItem(name, function(result){
		if(callback){
			callback(result);
		}
	});
}

function SCSetItem(key, value){
	if(window.plus){
		plus.storage.setItem(key, value);
	}else{
		$.cookie(key, value, { path: "/", expires: 30 });
	}
}

function SCGetItem(key){
	if(window.plus){
		return plus.storage.getItem(key);
	}else{
		return $.cookie(key);
	}
}

function SCRemoveItem(key){
	if(window.plus){
		plus.storage.removeItem(key);
	}else{
		$.removeCookie(key);
	}
}