$(function(){
	document.addEventListener('touchmove', function(e){ e.preventDefault(); }, false);
	FastClick.attach(document.body);
	
	$(".cl_video").fitVids();
	
	if(settings.debugMode === true){
		var testCourseId = "G01C00";
		loadCourseLearningData(testCourseId, true);
	}
});

function closeCLPage(){
	updateLastPlayingVideo(lastVideoId);
	WV.close("courseLearning", "");
}

function closeWebView(){
	closeCLPage();
}

var invoked = false;
function loadCourseLearningData(courseId, continuePlay){
	if(!invoked){
		invoked = true;
		var queryString = "courseId=" + courseId;
		var requestUrl = "/courses/" + courseId + "/learning";
		loadData("GET", requestUrl, queryString, false, function(status, response){
			if(status == 200){
				initialCourseLearningPage(response, continuePlay);
			}
		});
	}
}

var mscId = null, classId = null;
function loadCourseLearningData2(courseId, continuePlay, mineServiceClassId, serviceClassId){
	mscId = mineServiceClassId;
	classId = serviceClassId;
	
	loadCourseLearningData(courseId, continuePlay);
}

var courseId, posterUrl, defaultVideoId;
function initialCourseLearningPage(data, continuePlay){
	courseId = data.CourseInfo.CourseId;
	posterUrl = data.CourseInfo.GuideVideoPosterUrl;
	defaultVideoId = data.CourseVideoList[0].VideoId;
	
	setTimeout(function(){
		setCourseProperty(data);
		renderCLSectionList(data);
		
		setTimeout(function(){
			initialPlayer(data);
			processPlayerFullScreen(clPlayer);
			
			getMineCLData(courseId);
			if(continuePlay === true){
				continuePlaying();
			}else{
				selectVideo(defaultVideoId);
			}
		
			bindVideoItemClickEvent();
		}, 100);
		
		var defaultGroupId = groupIdArray[0];
		initialDefaultScroller(defaultGroupId);
		if(settings.platform == "ANDROID"){
			if(defaultScroller){
				defaultScroller.refresh();
			}
		}
		
		checkAndCreateScroller();
		$("#loadingPanel").hide();
		
		renderCLChapterList(data);
		renderCLRatedList(courseId);
		
		initialCourseRater();
		updateLearningProgress();
		
		if(continuePlay === false && data.CourseInfo.Price <= 0){
			ModifyCoursePurchaseCount();
		}else if(continuePlay === false && mscId != null && classId != null){
			ModifyCoursePurchaseCount();
		}
	}, settings.initialViewDelay);
}

function setCourseProperty(data){
	$("#cl_title").text(data.CourseInfo.CourseName);
	$("#cl_course_name").text(data.CourseInfo.CourseName);
	$("#cl_course_desc").text(data.CourseInfo.Description);
	
	$("#cl_section_count").text(data.CourseInfo.SectionCount);
	$("#cl_video_count").text(data.CourseInfo.VideoCount);
	$("#cl_purchase_count").text(data.CourseInfo.PurchaseCount);
}

var flag = false;
function bindVideoItemClickEvent(){
	$(document).on('tap', '.videoLink', function() {
		if(!flag){
			flag = true;
			setTimeout(function(){ flag = false; }, 500);
			
			var $this = $(this);
			var videoId = $this.attr("videoId");
			if(videoId){
				selectVideo(videoId, 0, true);
			}
		}
		
		return false;
	});
}

function renderCLSectionList(data){
	var htmlStr = template('cl_section_template', data);
	$("#cl_section_panel").html(htmlStr);
	
	if(settings.platform == "ANDROID"){
		if(defaultScroller){
			defaultScroller.refresh();
		}
	}
}

function renderCLChapterList(data){
	var htmlStr = template('cl_chapter_template', data);
	$("#cl_chapter_panel").html(htmlStr);
}

function renderCLRatedList(courseId){
	var requestUrl = "/courses/" + courseId + "/rated/1/" + settings.courseRatedPageSize;
	loadData("GET", requestUrl, "", false, function(status, response){
		if(status == 200){
			var htmlStr = template('cl_rated_template', response);
			$("#course_rated_panel").html(htmlStr);
		}
	});
}

function loadMoreCLRated(){
	var requestUrl = $(".more_rated_btn").attr("url") + settings.courseRatedPageSize;
	loadData("GET", requestUrl, "", false, function(status, response){
		if(status == 200){
			var htmlStr = template('cl_rated_template', response);
			$("#more_rated_panel").replaceWith(htmlStr);
		}
	});
}

var clPlayer;
function initialPlayer(data){
	var sourceUrl = data.CourseVideoList[0].VideoSourceUrl;
	clPlayer = jwplayer("cl_player").setup({
		"file": sourceUrl,
		"image": posterUrl + "?t=" + (new Date()).toString(),
		"width": "100%",
		"aspectratio": "16:9",
		"autostart": "false"
	});
	
	bindPlayerEvents(clPlayer);
}

var isPlaying; 
function bindPlayerEvents(player){
	if(player){
		player.on("ready", function(e){
			var documentHeight = $(document).height();
			var videoHeight = $(".cl_video").height();
			$(".cl_content").height((documentHeight - videoHeight) + "px");
			
			if(settings.platform == "IOS"){
				var container = player.getContainer();
				if(container){
					container.setAttribute("playsinline", "playsinline");
					container.setAttribute("webkit-playsinline", "webkit-playsinline");
				}
			}
		});
		
		player.on("time", function(e){
			if(isPlaying === true){
				updateVideoLastPlayTime(lastVideoId);
				checkVideoPlayCompleted(lastVideoId);
	        }
			
	        isPlaying = true;
		});
		
		player.on("play", function(e){
			setPlayingState(player, e, true);
			
        	updateLastPlayingVideo(lastVideoId);
			isPlaying = true;
		});
		
		player.on("seeked", function(e){
        	updateLastPlayingVideo(lastVideoId);
			isPlaying = true;
		});
		
		player.on("pause", function(e){
			setPlayingState(player, e, false);
			
        	updateLastPlayingVideo(lastVideoId);
			isPlaying = false;
		});
		
		player.on("complete", function(){
			if(completed === false){
				updateVideoPlayCompleted(lastVideoId);
			}
			
			isPlaying = false;
		});
	}
}

var groupIdArray = ["chapter", "detail", "rated"];
var defaultScroller;
function initialDefaultScroller(groupId){
	setTimeout(function() {
		defaultScroller = new IScroll("#wrapper_" + groupId, {
			scrollbars: true,
			probeType: 1,
			mouseWheel: true,
			interactiveScrollbars: true,
			shrinkScrollbars: 'scale',
			fadeScrollbars: true
		});
		
		scrollerMap[groupId] = defaultScroller;
	}, 1000);
}

var scrollerMap = {};
var scrollerTemp;
function checkAndCreateScroller(){
	$('#groupPanel a').on('click', function(){
	   var selectGroupId = $(this).attr("groupId");
	   for (var i = 0; i < groupIdArray.length; i++) {
			var groupId = groupIdArray[i];
			var scroller = scrollerMap[groupId];
			
			if(!scroller){
				if(selectGroupId == groupId){
					scrollerTemp = new IScroll("#wrapper_" + selectGroupId, {
						scrollbars: true,
						probeType: 1,
						mouseWheel: true,
						interactiveScrollbars: true,
						shrinkScrollbars: 'scale',
						fadeScrollbars: true
					});
					
					scrollerMap[selectGroupId] = scrollerTemp;
				}
			}else{
				if(selectGroupId == groupId){
					scroller.refresh();
				}
			}
		}
	});
}

var mclData;
function getMineCLData(courseId){
	var signState = getSignState();
	if(signState === true){
		var userId = getUserId();
		
		var requestUrl = "/mine/" + userId + "/courses/" + courseId + "/learning";
		if(mscId && classId){
			requestUrl = "/mine/" + userId + "/courses/" + courseId + "/classes/" + classId + "/learning/" + mscId;
		}
		
		loadData("GET", requestUrl, "", false, function(status, response){
			if(status == 200){
				mclData = response;
			}
		});
	}
}

var mclrData;
function getMineCLRData(courseId, videoId){
	var signState = getSignState();
	if(signState === true){
		var userId = getUserId();
		var requestUrl = "/mine/" + userId + "/courses/" + courseId + "/learning/" + videoId + "/record";
		loadData("GET", requestUrl, { "userId": userId, "courseId": courseId, "videoId": videoId }, false, function(status, response){
			if(status == 200){
				mclrData = response;
			}
		});
	}
}

function continuePlaying(){
	if(mclData && mclData.FirstTime === false){
		var mineCL = mclData.MineCL;
		if(mineCL){
			var videoId = mineCL.LastVideoId;
			var currentTime = mineCL.LastVideoCurrentTime;
			
			if(videoId){
				selectVideo(videoId, currentTime, true);
				
				setTimeout(function(){
					scrollSelect(videoId);
				}, 1500);
			}else{
				selectVideo(defaultVideoId);
			}
		}
	}
}

var lastVideoId;
function selectVideo(videoId, currentTime, isPlay){
	if(videoId){
		if(lastVideoId){
			$("#" + lastVideoId).removeClass("active");
		}
		
		var $selectItem = $("#" + videoId);
		$selectItem.addClass("active");
		
		if(clPlayer){
			var sourceUrl = $selectItem.attr("videoSourceUrl");
			clPlayer.load([{ file: sourceUrl, image: posterUrl }]);
			
			if(isPlay === true){
				clPlayer.play();
				
				if(currentTime && currentTime > 0){
					clPlayer.seek(currentTime); 
				}
			}
		}
		
		completed = false;
		getMineCLRData(courseId, videoId);
				
		lastVideoId = videoId;
	}
}

function scrollSelect(videoId){
	if(defaultScroller){
		var $selectItem = $("#" + videoId);
		var selectOffsetTop = $selectItem.offset().top;
		
		var $container = $("#wrapper_chapter");
		var containerScrollTop = $container.scrollTop();
		var containerOffsetTop = $container.offset().top;
		
		var target = selectOffsetTop - containerOffsetTop + containerScrollTop - 30;
		defaultScroller.scrollTo(0, -target, 100);
	}
}

function updateLearningProgress(){
	var signState = getSignState();
	if(signState === true){
		var userId = getUserId();
		var requestUrl = "/mine/" + userId + "/courses/" + courseId + "/learning/progress";
		loadData("POST", requestUrl, "", false, function(status, response){
			if(status == 200){
				console.log("update learning progress successed");
			}
		});
	}
}

var invoked = false;
function updateLastPlayingVideo(videoId){
	var signState = getSignState();
	if(signState === true && invoked === false){
		invoked = true;
		var updater = setTimeout(function(){
			var userId = getUserId();
			var currentTime = Math.round(clPlayer.getPosition());
			
			var requestUrl = "/mine/" + userId + "/courses/" + courseId + "/learning/" + videoId + "/last/" + currentTime;
			loadData("POST", requestUrl, "", false, function(status, response){
				if(status == 200){
					console.log("update last playing video successed");
				}
			});
			
			invoked = false;
			clearInterval(updater);
		}, 1000);
	}
}

var invoked1 = false;
function updateVideoLastPlayTime(videoId){
	var signState = getSignState();
	if(signState === true && invoked1 === false){
		invoked1 = true;
		var updater = setInterval(function(){
			if(isPlaying === true){
				var userId = getUserId();
				var requestUrl = "/mine/" + userId + "/courses/" + courseId + "/learning/" + videoId + "/lastPlayTime";
				
				loadData("POST", requestUrl, "", false, function(status, response){
					if(status == 200){
						console.log("update video last play time successed");
					}
				});
				
				invoked1 = false;
				clearInterval(updater);
			}
		}, 30000);
	}
}

var invoked2 = false;
function checkVideoPlayCompleted(videoId){
	if(invoked2 === false && completed === false){
		invoked2 = true;
		
		var duration = $("#" + videoId + " span[class='cc_video_duration']").text();
		var totalSeconds = timeToSecond(duration);
		
		var checker = setInterval(function(){
			if(isPlaying === true){
				var currentTime = Math.round(clPlayer.getPosition());
				
				if(totalSeconds - currentTime < 30){
					console.log("check video play completed successed");
					updateVideoPlayCompleted(videoId);
				}
				
				invoked2 = false;
				clearInterval(checker);
			}
		}, 30000);
	}
}

var invoked3 = false, completed = false;
function updateVideoPlayCompleted(videoId){
	var signState = getSignState();
	if(signState === true && invoked3 === false){
		invoked3 = true;
		
		var userId = getUserId();
		var requestUrl = "/mine/" + userId + "/courses/" + courseId + "/learning/" + videoId + "/completed";
		loadData("POST", requestUrl, "", false, function(status, response){
			if(status == 200){
				completed = true;
				console.log("update video play completed successed");
			}
			
			invoked3 = false;
		});
	}
}

function ModifyCoursePurchaseCount(){
	var requestUrl = "/courses/" + courseId + "/purchase/count";
	loadData("POST", requestUrl, "", false, function(status, response){
		if(status == 200){
			console.log("PurchaseCount Plus");
		}
	});
}

function showRatedSlidePanel(){
	var signState = getSignState();
	if(signState === true){
		checkCourseRatedCount();
	}else{
		showToast("请先登录", 100);
	}
}

function hideRatedSlidePanel(){
	setHasSP(false);
	$("#sp_rated_panel").animate({left: '100%'});
}

function hideSlidePanel(){
	hideRatedSlidePanel();
}

var rateValue = 10;
function initialCourseRater(){
	$("#cl_rater").barrating({
		theme: "fontawesome-stars",
		initialRating: 5,
		onSelect: function(value, text, event) {
			rateValue = 5 + Number(value);
			console.log(rateValue);
		}
	});
}

function checkCourseRatedCount(){
	var userId = getUserId();
	if(userId){
		var requestUrl = "/courses/" + courseId + "/rated/" + userId + "/check";
		loadData("POST", requestUrl, "", false, function(status, response){
			if(status == 200){
				if(response && response === true){
					$("#sp_rated_panel").animate({left: '0'});
					$("#menu").attr("data-mfb-state", "closed");
					setHasSP(true);
				}else{
					showToast("每人只能评价两次", 1000);
				}
			}
		});
	}
}

function submitCourseRate(){
	var signState = getSignState();
	if(signState === true){
		var userId = getUserId();
		var $rateInput = $("#rateComment");
		var rateComment = $rateInput.val().trim();
		if(!rateComment || rateComment == ""){
			$("#rateComment_error").text("请写下您对该课程的评价~");
			$rateInput.parent().addClass("is-invalid");
		}else{
			var requestUrl = "/courses/" + courseId + "/rated/" + userId + "/score/" + rateValue;
			loadData("POST", requestUrl, { "comment": rateComment }, false, function(status, response){
				if(status == 200){
					if(response && response === true){
						$rateInput.val("");
						document.querySelector("#mdl_tf_rate").MaterialTextfield.checkDirty();
						
						hideSlidePanel();
						setTimeout(function(){
							showToast("评价成功", 1000);
						}, 300);
					}
				}
			});
		}
	}
}

function timeToSecond(timeStr){
	var result = "";
	var timeArray = timeStr.split(':');

	var hour = 0, min = 0, sec = 0;
	if(timeArray.length == 3){
		hour = timeArray[0];
	    min = timeArray[1];
	    sec = timeArray[2];
	}else if(timeArray.length == 2){
		min = timeArray[0];
    	sec = timeArray[1];
	}else{
		sec = timeArray[2];
	}

    result = Number(hour * 3600) + Number(min * 60) + Number(sec);
    return result;
}
