var groupTemplateName = "groupTemplate";
var listTemplateName = "listTemplateIAT";
var listItemTemplateName = "listTemplateIAT_Item";

var courseType;
$(function(){
	document.addEventListener('touchmove', function(e){ e.preventDefault(); }, false);
	FastClick.attach(document.body);
	
	courseType = $("#courseType").val();
	loadCourseListData();
});

function closeWebView(){
	closeCourseListPage();
}

function closeCourseListPage(){
	if(courseType == 1){
		WV.close("courseList", "");
	}else if(courseType == 2){
		WV.close("courseList2", "");
	}else if(courseType == 3){
		WV.close("courseList3", "");
	}
}

function loadCourseListData(){
	var requestUrl;
	if(courseType == 1 || courseType == 2){
		requestUrl = "/courses/" + courseType + "/list/" + settings.coursePageSize;
	}else if(courseType == 3){
		requestUrl = "/courses/list/special/1/" + settings.coursePageSize;
	}
	
	loadData("GET", requestUrl, "", false, function(status, response) {
		if(status == 200) {
			initialCourseListPage(response);
		}
	});
}

var defaultImg = "../image/course-nothing.jpg";
function initialCourseListPage(data){
	//renderCourseGroup(data);
	renderCourseList(data);
	createCourseGroupTab(data);
	
	loadImg(defaultImg);
	bindCourseItemClickEvent();
	
	initialGroupPageMap(data);
	checkAndCreateScroller();
	
	$("#loadingPanel").hide();
}

function createTabItem(group){
	var a = document.createElement('a');
	
	a.id = "tabItem-" + group.GroupId;
    a.href = "#scroll-tab-" + group.GroupId;
    a.classList.add('mdl-layout__tab');
    a.textContent = group.GroupName;
    
    return a;
}

var layout = document.querySelector('.mdl-js-layout');
var tabBar = document.querySelector('.mdl-layout__tab-bar');
function createCourseGroupTab(data){
	setTimeout(function(){
		var groupList = data.GroupList;
		for (var i = 0; i < groupList.length; i++) {
			var group = groupList[i];
			
			var tabItem = createTabItem(group);
		    tabBar.appendChild(tabItem);
		}
		
		var tabs = document.querySelectorAll('.mdl-layout__tab');
		var panels = document.querySelectorAll('.mdl-layout__tab-panel');
		
		for (var i = 0; i < groupList.length; i++) {
			new MaterialLayoutTab(tabs[i], tabs, panels, layout.MaterialLayout);
		}
		
		var defaultTab = $("#tabItem-" + groupList[0].GroupId);
		defaultTab.addClass("is-active");
	}, 100);
}

var flag = false;
function bindCourseItemClickEvent(){
	$(document).on('tap', '.course-item', function() {
		if(!flag){
			flag = true;
			setTimeout(function(){ flag = false; }, 500);
			
			var $this = $(this);
			var courseId = $this.attr("courseId");
			if(courseId){
				var free = $(this).attr("free");
		        if(free == 1){
		        	openCoursePreviewFreeView(courseId, true);
		        }else{
		        	openCoursePreviewView(courseId, true);
		        }
			}
		}
		
		return false;
    });
}

function renderCourseGroup(data){
	var htmlStr = template(groupTemplateName, data);
	$("#groupPanel").html(htmlStr);
}

function renderCourseList(data){
	var htmlStr = template(listTemplateName, data);
	$("#listPanel").html(htmlStr);
}

var groupCount;
var groupIdArray = [];
var groupPageLoadedMap = {};
var groupPageNumberMap = {};
function initialGroupPageMap(data){
	groupCount = data.GroupList.length;
	for (var i = 0; i < groupCount; i++) {
		var group = data.GroupList[i];
		
		var tempGroupId = group.GroupId;
		groupIdArray.push(tempGroupId);
		groupPageLoadedMap[tempGroupId] = false;
		
		if(i == 0){
			groupPageNumberMap[tempGroupId] = 1;
			initialDefaultScroller(tempGroupId);
		}else{
			if(group.CourseCount > 0){
				groupPageNumberMap[tempGroupId] = 1;
				loadCoursePagedList(tempGroupId, 1);
			}else{
				groupPageNumberMap[tempGroupId] = 0;
			}
		}
	}
}

var scrollerMap = {};
var scrollerTemp;
function checkAndCreateScroller(){
	$('#groupPanel a').on('click',function(){
	   var selectGroupId = $(this).attr("groupId");
	   for (var i = 0; i < groupCount; i++) {
			var groupId = groupIdArray[i];
			var scroller = scrollerMap[groupId];
			
			if(!scroller){
				if(selectGroupId == groupId){
					setTimeout(function(){
						scrollerTemp = new IScroll("#wrapper_" + selectGroupId, {
							scrollbars: true,
							probeType: 3,
							mouseWheel: true,
							interactiveScrollbars: true,
							shrinkScrollbars: 'scale',
							fadeScrollbars: true
						});
						
						scrollerTemp.on("scroll", scrollLoadMore);
						scrollerMap[selectGroupId] = scrollerTemp;
					}, 100);
				}
			}else{
				if(selectGroupId == groupId){
					//scroller.refresh();
				}
			}
		}
	});
}

var defaultScroller;
function initialDefaultScroller(defaultGroupId){
	setTimeout(function() {
		defaultScroller = new IScroll("#wrapper_" + defaultGroupId, {
			scrollbars: true,
			probeType: 3,
			mouseWheel: true,
			interactiveScrollbars: true,
			shrinkScrollbars: 'scale',
			fadeScrollbars: true
		});
		
		defaultScroller.on("scroll", scrollLoadMore);
		scrollerMap[defaultGroupId] = defaultScroller;
	}, 800);
}

function loadCoursePagedList(groupId, page){
	getCourseList(groupId, page, function(groupId, data){
		var $container = $("#scroller_" + groupId);
		if(data.TotalCount > 0){
			var htmlStr = template(listItemTemplateName, data);
			$container.html(htmlStr);
			
			loadImg(defaultImg);
		}
	});
}

function getCourseList(groupId, page, callback){
	var requestUrl = "/courses/" + courseType + "/list/" + groupId + "/" + page + "/" + settings.coursePageSize;
	loadData("GET", requestUrl, "", false, function(status, response) {
		if(status == 200){
			callback(groupId, response);
		}
	});
}

var groupId, loaded, pageNumber;
function scrollLoadMore(){
	var y = parseInt(this.y);
	var maxScrollY = parseInt(this.maxScrollY);
	if((-y) > ((-maxScrollY) + 1)){
		groupId = $(".mdl-layout__tab.is-active").attr("groupId");
		loaded = groupPageLoadedMap[groupId];

		if(groupId && loaded === false){
			groupPageLoadedMap[groupId] = true;

			pageNumber = groupPageNumberMap[groupId];
			pageNumber = pageNumber + 1;
			
			var $loadMore;
			if(pageNumber > 1){
				$loadMore = $("#loadmore_" + groupId);
				$loadMore.show();
			}
			
			getCourseList(groupId, pageNumber, function(groupId, data){
				if(data.TotalCount > 0){
					groupPageNumberMap[groupId] = pageNumber;
					
					if(pageNumber == 1){
						var $nothing = $(".mdl-layout__tab-panel.is-active .list_nothing");
						
						var htmlStr = template(listItemTemplateName, data);
						$nothing.replaceWith(htmlStr);
					} else {
						var htmlStr = template(listItemTemplateName, data);
						$loadMore.replaceWith(htmlStr);
					}
					
					scrollerMap[groupId].refresh();
					loadImg(defaultImg);
				}
				
				if(data.TotalPage > pageNumber){
					groupPageLoadedMap[groupId] = false;
				}
			});
		}
	}
}
