$(function(){
	document.addEventListener('touchmove', function(e){ e.preventDefault(); }, false);
	
	loadCourseListData();
});

function closeWebView(){
	closeCourseListPage();
}

function closeCourseListPage(){
	WV.close("courseList2", "");
}

var groupTemplateName = "groupTemplate";
var listTemplateName = "listTemplateIAT";
var listItemTemplateName = "listTemplateIAT_Item";

var courseType = 2;
function loadCourseListData(){
	$("#course_list_title").text("真题讲解课程");
	
	var requestUrl = "/courses/" + courseType + "/list/" + settings.coursePageSize;
	loadData("GET", requestUrl, "", false, function(status, response) {
		if(status == 200) {
			initialCourseListPage(response);
		}
	});
}

var defaultImg = "../image/course-nothing.jpg";
var defaultScroller;

function initialCourseListPage(data){
	renderGroup(data);
	renderList(data);
	loadImg(defaultImg);
	
	initialGroupPageMap(data);
	checkAndCreateScroller();
	
	$("#loadingPanel").hide();
}

function initialDefaultScroller(groupId){
	setTimeout(function() {
		defaultScroller = new IScroll("#wrapper_" + groupId, {
			scrollbars: true,
			probeType: 3,
			mouseWheel: true,
			interactiveScrollbars: true,
			shrinkScrollbars: 'scale',
			fadeScrollbars: true
		});
		
		defaultScroller.on("scroll", scrollLoadMore);
		scrollerMap[groupId] = defaultScroller;
	}, 100);
}

var groupPageLoadedMap = {};
var groupPageNumberMap = {};
var groupIdArray = [];
function initialGroupPageMap(data){
	var groupCount = data.GroupList.length;
	for (var i = 0; i < groupCount; i++) {
		var group = data.GroupList[i];
		
		groupIdArray.push(group.GroupId);
		groupPageLoadedMap[group.GroupId] = false;
		
		if(i == 0){
			groupPageNumberMap[group.GroupId] = 1;
			initialDefaultScroller(group.GroupId);
		}else{
			if(group.CourseCount > 0){
				groupPageNumberMap[group.GroupId] = 1;
				loadCourseList(group.GroupId);
			}else{
				groupPageNumberMap[group.GroupId] = 0;
			}
		}
	}
}

var scrollerTemp;
var scrollerMap = {};
function checkAndCreateScroller(){
	$('#groupPanel a').on('click',function(){
	   var gId = $(this).attr("groupId");
	   for (var i = 0; i < groupIdArray.length; i++) {
			var groupId = groupIdArray[i];
			var scroller = scrollerMap[groupId];
			if(gId == groupId && !scroller){
				scrollerTemp = new IScroll("#wrapper_" + groupId, {
					scrollbars: true,
					probeType: 3,
					mouseWheel: true,
					interactiveScrollbars: true,
					shrinkScrollbars: 'scale',
					fadeScrollbars: true
				});
				
				scrollerTemp.on("scroll", scrollLoadMore);
				scrollerMap[groupId] = scrollerTemp;
			}
		}
	});
}

function loadCourseList(groupId){
	var pageNumber = groupPageNumberMap[groupId];
	
	getCourseList(groupId, pageNumber, function(groupId, data){
		var $container = $("#scroller_" + groupId);
		if(data.TotalCount > 0){
			var htmlStr = template(listItemTemplateName, data);
			$container.html(htmlStr);
			
			loadImg(defaultImg);
		}
	});
}

var groupId, loaded, pageNumber;
function scrollLoadMore(){
	var y = parseInt(this.y);
	var maxScrollY = parseInt(this.maxScrollY);
	if((-y) > ((-maxScrollY) + 1)) {
		groupId = $(".mdl-layout__tab.is-active").attr("groupId");
		if(groupId) {
			var $loadMore = $("#loadmore_" + groupId);
			loaded = groupPageLoadedMap[groupId];
			if(loaded === false) {
				groupPageLoadedMap[groupId] = true;
				$loadMore.show();
				
				setTimeout(function() {
					pageNumber = groupPageNumberMap[groupId];
					pageNumber = pageNumber + 1;
					
					getCourseList(groupId, pageNumber, function(groupId, data){
						if(pageNumber == 1){
							var $nothing = $(".mdl-layout__tab-panel.is-active .list_nothing");
							if(data.TotalCount > 0){
								var htmlStr = template(listItemTemplateName, data);
								$nothing.replaceWith(htmlStr);
							}
						}else{
							var htmlStr = template(listItemTemplateName, data);
							$loadMore.replaceWith(htmlStr);
						}
						
						loadImg(defaultImg);
						scrollerMap[groupId].refresh();
						
						groupPageNumberMap[groupId] = pageNumber;
						if(data.TotalPage > pageNumber){
							groupPageLoadedMap[groupId] = false;
						}
					});
				}, settings.loadDataDelay);
			}
		}
	}
}

function getCourseList(groupId, page, callback){
	var requestUrl = "/courses/" + courseType + "/list/" + groupId + "/" + page + "/" + settings.coursePageSize;
	loadData("GET", requestUrl, "", false, function(status, response) {
		if(status == 200){
			callback(groupId, response);
		}
	});
}

function renderGroup(data){
	var htmlString = template(groupTemplateName, data);
	$("#groupPanel").html(htmlString);
}

function renderList(data){
	var htmlString = template(listTemplateName, data);
	$("#listPanel").html(htmlString);
}