$(function(){
	FastClick.attach(document.body);
	
	if(settings.debugMode === true){
		var testCourseId = "G04C01";
		loadCoursePreviewFreeData(testCourseId);
	}
});

function closeCPFPage(){
	WV.close('coursePreviewFree', '');
}

function closeWebView(){
	closeCPFPage();
}

function loadCoursePreviewFreeData(courseId){
	var requestUrl = "/courses/" + courseId + "/preview/free";
	loadData("GET", requestUrl, "", false, function(status, response){
		if(status == 200){
			initialCoursePreviewFreePage(response);
		}
	});
}

var courseId;
function initialCoursePreviewFreePage(data){
	courseId = data.CourseInfo.CourseId;
	setCourseProperty(data);
	
	setTimeout(function(){
		renderCPFStartButton(data);
		checkLearningState(courseId);
		
		renderCPFRatedLink(data);
		renderCPFRated(data);
		renderCPFChapter(data);
		
		$("#loadingPanel").hide();
	}, settings.initialViewDelay);
}

function setCourseProperty(data){
	$("#cpf_title").text(data.CourseInfo.CourseName);
	$("#cpf_description").text(data.CourseInfo.Description);
	
	$("#cpf_section_count").text(data.CourseInfo.SectionCount);
	$("#cpf_video_count").text(data.CourseInfo.VideoCount);
	$("#cpf_purchase_count").text(data.CourseInfo.PurchaseCount);
	
	$(".cpf_rated_score").text(data.CourseInfo.RatedScore);
	$("#cpf_rated_count").text(data.CourseInfo.RatedCount);
	
	if(data.CourseInfo.RatedCount <= 0){
		$("#cpf_rated").hide();
	}
}

function startLearning(continuePlay){
	var signState = getSignState();
	if(signState === true){
		changeStartLearningBtnState();
		openCourseLearningView(courseId, continuePlay);
	}else{
		showToast("登录以后才能学习哦", 1000);
	}
}

function checkLearningState(courseId){
	var signState = getSignState();
	if(signState === true){
		var userId = getUserId();
		
		var requestUrl = "/courses/" + courseId + "/preview/free/" + userId + "/check";
		loadData("POST", requestUrl, "", false, function(status, response){
			if(status == 200){
				if(response.HasLearning === true){
					changeStartLearningBtnState();
				}
			}
		});
	}
}

function changeStartLearningBtnState(){
	var $startLearningBtn = $(".start_learn_btn");
	var continueHref = "javascript:startLearning(true)";
	$startLearningBtn.attr("href", continueHref);
	$startLearningBtn.text("继续学习");
}

function renderCPFRatedLink(data){
	var htmlStr = template('cpf_rated_link_template', data);
	$("#cpf_rated_input").replaceWith(htmlStr);
}

function renderCPFRated(data){
	var htmlStr = template('cpf_rated_template', data);
	$("#course_rated_panel").html(htmlStr);
}

function renderCPFChapter(data){
	var htmlStr = template('cpf_chapter_template', data);
	$("#cpf_section_panel").html(htmlStr);
}

function renderCPFStartButton(data){
	var htmlStr = template('cpf_start_learn_template', data);
	$(".start_learn").html(htmlStr);
}