document.addEventListener('touchmove', function(e){
	if(VIEW.CurrentName.toLowerCase() == "course"){
		e.preventDefault();
	}
}, false);

var defaultImg = "image/course-nothing.jpg";
function initialCoursePage(data, fromCache){
	renderCourseGroup(data);
	renderCourseList(data);
	
	loadImg(defaultImg);
	bindCourseItemClickEvent();
	
	initialGroupPageMap(data);
	checkAndCreateScroller();
	
    $("#loadingPanel").hide();
}

var flag = false;
function bindCourseItemClickEvent(){
	$(document).on('tap', '.course-item', function() {
		if(!flag){
			flag = true;
			setTimeout(function(){ flag = false; }, 500);
			
			var $this = $(this);
			var courseId = $this.attr("courseId");
			if(courseId){
				var free = $(this).attr("free");
		        if(free == 1){
		        	openCoursePreviewFreeView(courseId, false);
		        }else{
		        	openCoursePreviewView(courseId, false);
		        }
			}
		}
		
		return false;
    });
}

var groupTemplateName = "courseGroupTemplate";
function renderCourseGroup(data){
	var htmlStr = template(groupTemplateName, data);
	$("#courseGroupPanel").html(htmlStr);
}

var listTemplateName = "courseListTemplateIAT";
function renderCourseList(data){
	var htmlStr = template(listTemplateName, data);
	$("#courseListPanel").html(htmlStr);
}

var groupCount;
var groupIdArray = [];
var groupPageLoadedMap = {};
var groupPageNumberMap = {};
function initialGroupPageMap(data){
	groupCount = data.GroupList.length;
	for (var i = 0; i < groupCount; i++) {
		var group = data.GroupList[i];
		
		var tempGroupId = group.GroupId;
		groupIdArray.push(tempGroupId);
		groupPageLoadedMap[tempGroupId] = false;
		
		if(i == 0){
			groupPageNumberMap[tempGroupId] = 1;
			initialDefaultScroller(tempGroupId);
		}else{
			if(group.CourseCount > 0){
				groupPageNumberMap[tempGroupId] = 1;
				loadCoursePagedList(tempGroupId, 1);
			}else{
				groupPageNumberMap[tempGroupId] = 0;
			}
		}
	}
}

var defaultScroller;
function initialDefaultScroller(defaultGroupId){
	setTimeout(function() {
		defaultScroller = new IScroll("#wrapper_" + defaultGroupId, {
			scrollbars: true,
			probeType: 3,
			mouseWheel: true,
			interactiveScrollbars: true,
			shrinkScrollbars: 'scale',
			fadeScrollbars: true
		});
		
		defaultScroller.on("scroll", scrollLoadMore);
		scrollerMap[defaultGroupId] = defaultScroller;
	}, 800);
}

var scrollerMap = {};
var scrollerTemp;
function checkAndCreateScroller(){
	$('#courseGroupPanel a').on('click',function(){
	   var selectGroupId = $(this).attr("groupId");
	   for (var i = 0; i < groupCount; i++) {
			var groupId = groupIdArray[i];
			var scroller = scrollerMap[groupId];
			
			if(!scroller){
				if(selectGroupId == groupId){
					setTimeout(function(){
						scrollerTemp = new IScroll("#wrapper_" + selectGroupId, {
							scrollbars: true,
							probeType: 3,
							mouseWheel: true,
							interactiveScrollbars: true,
							shrinkScrollbars: 'scale',
							fadeScrollbars: true
						});
						
						scrollerTemp.on("scroll", scrollLoadMore);
						scrollerMap[selectGroupId] = scrollerTemp;
					}, 100);
				}
			}else{
				if(selectGroupId == groupId){
					//scroller.refresh();
				}
			}
		}
	});
}

var listItemTemplateName = "courseListTemplateIAT_Item";
function loadCoursePagedList(groupId, page){
	getCourseData(groupId, page, function(groupId, data){
		var $container = $("#scroller_" + groupId);
		if(data.TotalCount > 0){
			var htmlStr = template(listItemTemplateName, data);
			$container.html(htmlStr);
			
			loadImg(defaultImg);
		}
	});
}

function getCourseData(groupId, page, callback){
	var requestUrl = "/courses/list/" + groupId + "/" + page + "/" + settings.coursePageSize;
	loadData("GET", requestUrl, "", false, function(status, response) {
		if(status == 200){
			callback(groupId, response);
		}
	});
}

var groupId, loaded, pageNumber;
function scrollLoadMore() {
	var y = parseInt(this.y);
	var maxScrollY = parseInt(this.maxScrollY);
	if((-y) > ((-maxScrollY) + 1)){
		groupId = $(".mdl-layout__tab.is-active").attr("groupId");
		loaded = groupPageLoadedMap[groupId];
		
		if(groupId && loaded === false){
			groupPageLoadedMap[groupId] = true;
			
			pageNumber = groupPageNumberMap[groupId];
			pageNumber = pageNumber + 1;
			
			var $loadMore;
			if(pageNumber > 1){
				$loadMore = $("#loadmore_" + groupId);
				$loadMore.show();
			}
			
			getCourseData(groupId, pageNumber, function(groupId, data){
				if(data.TotalCount > 0){
					groupPageNumberMap[groupId] = pageNumber;
					
					if(pageNumber == 1){
						var $nothing = $(".mdl-layout__tab-panel.is-active .list_nothing");
						
						var htmlStr = template(listItemTemplateName, data);
						$nothing.replaceWith(htmlStr);
					}else{
						var htmlStr = template(listItemTemplateName, data);
						$loadMore.replaceWith(htmlStr);
					}
					
					scrollerMap[groupId].refresh();
					loadImg(defaultImg);
				}
				
				if(data.TotalPage > pageNumber) {
					groupPageLoadedMap[groupId] = false;
				}
			});
		}
	}
}