$(function(){
	document.addEventListener('touchmove', function(e){ e.preventDefault(); }, false);
	FastClick.attach(document.body);
	
	if(settings.debugMode === true){
		loadMineCourseData();
	}
});

function closeMineCoursePage(){
	WV.close("mineCourse", "");
}

function closeWebView(){
	refreshMinePageState();
	closeMineCoursePage();
}

function getRequestUrl(userId, groupId, page){
	var requestUrl = null;
	if(groupId == "MCL"){
		requestUrl = "/mine/" + userId + "/course/list/" + page + "/" + settings.mineCoursePageSize;
	}else if(groupId == "MFC"){
		// get favorite course list url
	}
	return requestUrl;
}

function getMineCourseList(userId, groupId, page, callback){
	var requestUrl = getRequestUrl(userId, groupId, page);
	loadData("GET", requestUrl, "", false, function(status, response) {
		if(status == 200 && response != null){
			callback(groupId, response);
		}
	});
}

var defaultImg = "../image/course-nothing.jpg";
function loadMineCourseData(){
	var signState = getSignState();
	if(signState === true){
		var userId = getUserId();
		getMineCourseList(userId, "MCL", 1, function(groupId, data){
			renderMCLList(groupId, data);
			
			loadImg(defaultImg);
			bindMineCourseItemClickEvent();
			
			initialGroupPageMap();
			checkAndCreateScroller();
			
			bindTeacherClickEvent();
			
			updateMCLState(data);
			updateMCLProgress(data);
			componentHandler.upgradeDom();
			
			$("#loadingPanel").hide();
		});
	}else{
		showError("请重新登录", 1000);
	}
}

function renderMCLList(groupId, data){
	if(data.MineCLList != null){
		var htmlStr = template("mineCourseTemplate", data);
		$("#scroller_" + groupId).html(htmlStr);
	}
}

var flag = false;
function bindMineCourseItemClickEvent(){
	$('.mc_item_continue').on('tap', function(){
		if(!flag){
			flag = true;
			setTimeout(function(){ flag = false; }, 500);
			
			var $this = $(this);
			var courseId = $this.attr("courseId");
			if(courseId){
				openCourseLearningView(courseId);
			}
		}
		
		return false;
    });
}

var groupCount = 2;
var groupIdArray = ["MCL", "MFC"];
var groupPageLoadedMap = {};
var groupPageNumberMap = {};
function initialGroupPageMap(){
	for (var i = 0; i < groupCount; i++) {
		var groupId = groupIdArray[i];
		groupPageLoadedMap[groupId] = false;
		
		if(i == 0){
			groupPageNumberMap[groupId] = 1;
			initialDefaultScroller(groupId);
		}else{
			groupPageNumberMap[groupId] = 0;
		}
	}
}

var defaultScroller;
function initialDefaultScroller(groupId){
	setTimeout(function() {
		defaultScroller = new IScroll("#wrapper_" + groupId, {
			scrollbars: true,
			probeType: 3,
			mouseWheel: true,
			interactiveScrollbars: true,
			shrinkScrollbars: 'scale',
			fadeScrollbars: true
		});
		
		defaultScroller.on("scroll", scrollLoadMore);
		scrollerMap[groupId] = defaultScroller;
	}, 1000);
}

var scrollerMap = {};
var scrollerTemp;
function checkAndCreateScroller(){
	$('#groupPanel a').on('click',function(){
	   var selectGroupId = $(this).attr("groupId");
	   for (var i = 0; i < groupCount; i++) {
			var groupId = groupIdArray[i];
			var scroller = scrollerMap[groupId];
			
			if(!scroller){
				if(selectGroupId == groupId){
					setTimeout(function(){
						scrollerTemp = new IScroll("#wrapper_" + selectGroupId, {
							scrollbars: true,
							probeType: 3,
							mouseWheel: true,
							interactiveScrollbars: true,
							shrinkScrollbars: 'scale',
							fadeScrollbars: true
						});
						
						scrollerTemp.on("scroll", scrollLoadMore);
						scrollerMap[selectGroupId] = scrollerTemp;
					}, 100);
				}
			}else{
				if(selectGroupId == groupId){
					//scroller.refresh();
				}
			}
		}
	});
}

var groupId, loaded, pageNumber;
function scrollLoadMore() {
	var y = parseInt(this.y);
	var maxScrollY = parseInt(this.maxScrollY);
	if((-y) > ((-maxScrollY) + 1)) {
		groupId = $(".mdl-layout__tab.is-active").attr("groupId");
		loaded = groupPageLoadedMap[groupId];

		if(groupId && loaded === false) {
			groupPageLoadedMap[groupId] = true;

			pageNumber = groupPageNumberMap[groupId];
			pageNumber = pageNumber + 1;

			var $loadMore;
			if(pageNumber > 1) {
				$loadMore = $("#loadmore_" + groupId);
				$loadMore.show();
			}

			setTimeout(function(){
				var userId = getUserId();
				getMineCourseList(userId, groupId, pageNumber, function(groupId, data) {
					if(data.MineCLList.TotalCount > 0){
						groupPageNumberMap[groupId] = pageNumber;
						
						if(pageNumber == 1){
							var $nothing = $(".mdl-layout__tab-panel.is-active .list_nothing");
							
							var htmlStr = template("mineCourseTemplate", data);
							$nothing.replaceWith(htmlStr);
						}else{
							var htmlStr = template("mineCourseTemplate", data);
							$loadMore.replaceWith(htmlStr);
						}
						
						scrollerMap[groupId].refresh();
						loadImg(defaultImg);
						
						updateMCLState(data);
						updateMCLProgress(data);
						componentHandler.upgradeDom();
					}
					
					if(data.MineCLList.TotalPage > pageNumber) {
						groupPageLoadedMap[groupId] = false;
					}
				});
			}, settings.loadDataDelay);
		}
	}
}

function bindTeacherClickEvent(){
	$(".teacherName").on("tap", function(e){
		var teacherId = $(this).attr("teacherId");
		if(teacherId){
			openTeacherInfoView(teacherId);
		}
		
		e.stopPropagation();
	});
}

var firstStartMap = {};
function updateMCLState(data){
	if(data.MineCLList != null){
		if(data.MineCLList.TotalCount > 0){
			var mclList = data.MineCLList.Data;
			if(mclList){
				for (var i = 0; i < mclList.length; i++) {
					var item = mclList[i];
					
					var icon, name;
					if(item.LastLearningTime){
						firstStartMap[item.CourseId] = false;
						
						if(item.LearningProgress == 100){
							icon = "&#xE042;";
							name = "复习一遍";
						}else{
							icon = "&#xE192;";
							name = "继续学习";
						}
					}else{
						firstStartMap[item.CourseId] = true;
						
						icon = "&#xE039;";
						name = "开始学习";
					}
					
					$("#icon_" + item.CourseId).html(icon);
					$("#text_" + item.CourseId).html(name);
				}
			}
		}
	}
}

function updateMCLProgress(data){
	if(data.MineCLList != null){
		if(data.MineCLList.TotalCount > 0){
			var mclList = data.MineCLList.Data;
			if(mclList){
				for(var i = 0; i < mclList.length; i++) {
					var item = mclList[i];
					setProgressBar(item.CourseId, item.LearningProgress);
				}
			}
		}
	}
}

function setProgressBar(courseId, progressValue){
	document.querySelector('#progress_' + courseId).addEventListener('mdl-componentupgraded', function() {
		this.MaterialProgress.setProgress(progressValue);
	});
}

function openCourseLearningView(courseId){
	var wvName = "courseLearning";
	var wvCL = WV.load(wvName);
	var viewObj = window[wvName];
	var firstStart = firstStartMap[courseId];
	
	if(settings.platform == "IOS"){
		wvCL.addEventListener("loaded", function(e){
			if(firstStart === true){
				wvCL.evalJS("loadCourseLearningData('" + courseId + "', false)");
			}else{
				wvCL.evalJS("loadCourseLearningData('" + courseId + "', true)");
			}
			
			setTimeout(function(){
				var animation = viewObj.ShowAnimation;
				wvCL.show(animation, WV.AnimationDuration, function() {
					WV.showedCB(wvName, "");
				});
			}, settings.openWebviewDelay);
		}, false);
	}else{
		if(firstStart === true){
			wvCL.evalJS("loadCourseLearningData('" + courseId + "', false)");
		}else{
			wvCL.evalJS("loadCourseLearningData('" + courseId + "', true)");
		}
		
		wvCL.addEventListener("titleUpdate", function(e){
			setTimeout(function(){
				var animation = viewObj.ShowAnimation;
				wvCL.show(animation, WV.AnimationDuration, function() {
					WV.showedCB(wvName, "");
				});
			}, settings.openWebviewDelay);
		}, false);
	}
}

function openTeacherInfoView(teacherId){
	var wvName = "teacher";
	var wvTeacher = WV.load2(wvName);
	var viewObj = window[wvName];
	
	if(settings.platform == "IOS"){
		wvTeacher.addEventListener("loaded", function(e){
			wvTeacher.evalJS("loadTeacherData('" + teacherId + "')");
			
			setTimeout(function(){
				var animation = viewObj.ShowAnimation;
				wvTeacher.show(animation, WV.AnimationDuration, function() {
					WV.showedCB(wvName, "");
				});
			}, settings.openWebviewDelay);
		}, false);
	}else{
		wvTeacher.evalJS("loadTeacherData('" + teacherId + "')");
		
		wvTeacher.addEventListener("titleUpdate", function(e){
			setTimeout(function(){
				var animation = viewObj.ShowAnimation;
				wvTeacher.show(animation, WV.AnimationDuration, function() {
					WV.showedCB(wvName, "");
				});
			}, settings.openWebviewDelay);
		}, false);
	}
}