$(function(){
	FastClick.attach(document.body);
	
	if(settings.debugMode === true){
		var testOrderNumber = "";
		loadMineOrderInfo(testOrderNumber);
	}
});

function closeWebView(){
	closeMineOrderInfoPage();
}

function closeMineOrderInfoPage(){
	WV.close('mineOrderInfo', '');
}

function getOrderInfo(orderNumber, callback){
	var requestUrl = "/orders/info/" + orderNumber;
	loadData("GET", requestUrl, "", false, function(status, response){
		if(status == 200){
			callback(response);
		}
	});
}

var orderInfo;
function loadMineOrderInfo(orderNumber){
	getOrderInfo(orderNumber, function(data){
		if(data.Exists){
			orderInfo = data;
			setOrderProperty(orderInfo);
			
			$("#loadingPanel").hide();
		}
	});
}

var paymentMethod, orderNumber, orderStatus;
function setOrderProperty(data){
	var orderInfo = data.OrderInfo;
	var product = data.OrderDetails[0];
	var productId = product.TargetId;
	
	paymentMethod = orderInfo.PaymentMethod;
	orderNumber = orderInfo.OrderNumber;
	orderStatus = orderInfo.OrderStatus;
	
	$("#orderNumber").text("订单编号：" + orderNumber);
	
	var imageDomain = settings.courseImageDomain;
	var extension = settings.courseImageExtension;
	var thumbnailSize = settings.courseThumbnailSize;
	
	var t = $.format.date(new Date(), "yyyyMMddHHmm");
	var productImage = imageDomain + productId + "-" + thumbnailSize + extension + "?t=" + t;
	
	$("#productImage").attr("src", productImage);
	
	$("#productName").html(product.TargetName);
	$("#productPrice").html("￥" + product.Price);
	
	var orderTime = $.format.date(orderInfo.CreatedTime, "yyyy-MM-dd HH:mm:ss");
	$("#orderTime").text(orderTime);
	
	var statusText;
	if(orderStatus == 1){
		statusText = "";
		$("#orderActions").show();
		$(".purchase_panel").show();
	}else if(orderStatus == 2){
		if(orderInfo.ClosedType == 1){
			statusText = "已过期";
		}else if(orderInfo.ClosedType == 2){
			statusText = "已关闭";
		}
	}else if(orderStatus == 3){
		statusText = "已完成";
		$("#orderActions").hide();
		$(".purchase_panel").hide();
		
		var hrefCode;
		if(product.TargetType == 1){
			hrefCode = "javascript:openMineCourseViewFromOrderInfo();";
		}else if(product.TargetType == 2){
			hrefCode = "javascript:openMineServiceViewFromOrderInfo()";
		}
		
		$("#btnStart").attr("href", hrefCode);
		$(".start_panel").show();
	}
	
	$("#orderStatus").text(statusText);
	
	var pmLogoSrc;
	if(paymentMethod == 1){
		pmLogoSrc = "../image/payment/payment_wechat.png";
	}else if(paymentMethod == 2){
		pmLogoSrc = "../image/payment/payment_alipay.png";
	}
	
	$("#PMLogo").attr("src", pmLogoSrc);
	
	$("#totalAmount").text("￥" + toDecimal(orderInfo.TotalAmount));
	$("#derateAmount").text("-￥" + toDecimal(orderInfo.DerateAmount));
	$("#paymentAmount").text("￥" + toDecimal(orderInfo.PaymentAmount));
	$("#paymentAmount2").text("￥" + toDecimal(orderInfo.PaymentAmount));
}

function orderPaymentNow(){
	if(orderStatus == 1){
		orderPayment(orderNumber, paymentMethod);
	}
}

function orderCancel(){
	var signState = getSignState();
	if(signState === true){
		weui.confirm('确定要取消订单？', {
			title: '',
			buttons: [{
				label: '取消',
				type: 'default',
				onClick: function() {
					console.log("用户取消订单");
				}
			}, {
				label: '确定',
				type: 'primary',
				onClick: function() {
					var requestUrl = "/orders/cancel/" + orderNumber;
					loadData("POST", requestUrl, "", false, function(status, response){
						if(status == 200){
							if(response == true){
								$("#orderActions").hide();
								$(".purchase_panel").hide();
								$("#orderStatus").text("已关闭");
								
								showToast("订单已取消", 1000);
							}else{
								showError("取消订单失败", 1500);
							}
						}
					});
				}
			}]
		});
	}else{
		showError("请重新登录", 1000);
	}
}
