$(function(){
	document.addEventListener('touchmove', function(e){ e.preventDefault(); }, false);
	FastClick.attach(document.body);
	
	if(settings.debugMode === true){
		loadMineOrderData();
	}
});

function closeMineOrderPage(){
	WV.close("mineOrder", "");
}

function closeWebView(){
	refreshMinePageState();
	closeMineOrderPage();
}

function getMineOrderList(groupId, pageNumber, callback){
	var signState = getSignState();
	if(signState === true){
		var userId = getUserId();
		var paid = groupId == "unpaid" ? false : true;
		
		var requestUrl = "/orders/list/" + userId + "/payment/" + paid + "/" + pageNumber + "/" + settings.mineOrderPageSize;
		loadData("GET", requestUrl, "", false, function(status, response){
			if(status == 200){
				callback(paid, response);
			}
		});
	}
}

var defaultImg = "../image/course-nothing.jpg";
function loadMineOrderData(){
	getMineOrderList("unpaid", 1, function(paid, data){
		renderOrderList(paid, data);
		
		loadImg(defaultImg);
		bindMineOrderItemClickEvent();
		bindMineOrderPaymentClickEvent();
		
		initialGroupPageMap();
		checkAndCreateScroller();
		
		$("#loadingPanel").hide();
	});
}

var flag = false;
function bindMineOrderItemClickEvent(){
	$(document).on('tap', '.product_item', function(e){
		if(!flag){
			flag = true;
			setTimeout(function(){ flag = false; }, 500);
		
			var $this = $(this);
			var orderNumber = $this.attr("orderNumber");
			if(orderNumber){
				openMineOrderInfoView(orderNumber);
			}
		}
		
		return false;
    });
}

var flag1 = false;
function bindMineOrderPaymentClickEvent(){
	$(document).on('tap', '.oi_payment_btn', function(){
		if(!flag1){
			flag1 = true;
			setTimeout(function(){ flag1 = false; }, 500);
		
			var $this = $(this);
			var orderNumber = $this.attr("orderNumber");
			var paymentMethod = $this.attr("paymentMethod");
			if(orderNumber && paymentMethod){
				orderPayment(orderNumber, paymentMethod);
			}
		}
		
		return false;
    });
}

function renderOrderList(paid, data){
	if(data.Exists === true){
		if(paid === true){
			renderPaidOrderList(data);
		}else{
			renderUnPaidOrderList(data);
		}
	}
}

function renderPaidOrderList(data){
	var htmlString = template('list_template', data);
	$("#paid_nothing").replaceWith(htmlString);
}

function renderUnPaidOrderList(data){
	var htmlString = template('list_template', data);
	$("#unpaid_nothing").replaceWith(htmlString);
}

var groupCount = 2;
var groupIdArray = ["unpaid", "paid"];
var groupPageLoadedMap = {};
var groupPageNumberMap = {};
function initialGroupPageMap(data){
	for (var i = 0; i < groupCount; i++) {
		var groupId = groupIdArray[i];
		groupPageLoadedMap[groupId] = false;
		
		if(i == 0){
			groupPageNumberMap[groupId] = 1;
			initialDefaultScroller(groupId);
		}else{
			groupPageNumberMap[groupId] = 1;
			loadMineOrderList(groupId, 1);
		}
	}
}

var defaultScroller;
function initialDefaultScroller(groupId){
	setTimeout(function() {
		defaultScroller = new IScroll("#wrapper_" + groupId, {
			scrollbars: true,
			probeType: 3,
			mouseWheel: true,
			interactiveScrollbars: true,
			shrinkScrollbars: 'scale',
			fadeScrollbars: true
		});
		
		defaultScroller.on("scroll", scrollLoadMore);
		scrollerMap[groupId] = defaultScroller;
	}, 1000);
}

function loadMineOrderList(groupId, page){
	getMineOrderList(groupId, page, function(paid, data){
		if(data.Exists === true){
			renderOrderList(paid, data);
		}
	});
}

var scrollerMap = {};
var scrollerTemp;
function checkAndCreateScroller(){
	$('#groupPanel a').on('click',function(){
	   var selectGroupId = $(this).attr("payment");
	   for (var i = 0; i < groupCount; i++) {
			var groupId = groupIdArray[i];
			var scroller = scrollerMap[groupId];
			
			if(!scroller){
				if(selectGroupId == groupId){
					scrollerTemp = new IScroll("#wrapper_" + selectGroupId, {
						scrollbars: true,
						probeType: 3,
						mouseWheel: true,
						interactiveScrollbars: true,
						shrinkScrollbars: 'scale',
						fadeScrollbars: true
					});
					
					scrollerTemp.on("scroll", scrollLoadMore);
					scrollerMap[selectGroupId] = scrollerTemp;
				}
			}else{
				if(selectGroupId == groupId){
					//scroller.refresh();
				}
			}
		}
	});
}

var groupId;
function scrollLoadMore(){
	var y = parseInt(this.y);
	var maxScrollY = parseInt(this.maxScrollY);
	if((-y) > ((-maxScrollY) + 1)) {
		groupId = $(".mdl-layout__tab.is-active").attr("payment");
		loaded = groupPageLoadedMap[groupId];
		
		if(groupId && loaded === false){
			groupPageLoadedMap[groupId] = true;
			
			pageNumber = groupPageNumberMap[groupId];
			pageNumber = pageNumber + 1;
			
			var $loadMore;
			if(pageNumber > 1) {
				$loadMore = $("#scroller_" + groupId + " .weui-loadmore");
				$loadMore.show();
			}
			
			getMineOrderList(groupId, pageNumber, function(paid, data){
				if(data.Exists === true){
					groupPageNumberMap[groupId] = pageNumber;
					
					if(pageNumber == 1){
						renderOrderList(paid, data);
					}else{
						renderOrderList2(paid, data, $loadMore);
					}
					
					scrollerMap[groupId].refresh();
					loadImg(defaultImg);
				}
				
				if(data.TotalPage > pageNumber){
					groupPageLoadedMap[groupId] = false;
				}
			});
		}
	}
}

function renderOrderList2(paid, data, $loadMore){
	if(paid === true){
		renderPaidOrderList2(data, $loadMore);
	}else{
		renderUnPaidOrderList2(data, $loadMore);
	}
}

function renderPaidOrderList2(data, $loadMore){
	var htmlString = template('list_template', data);
	$loadMore.replaceWith(htmlString);
}

function renderUnPaidOrderList2(data, $loadMore){
	var htmlString = template('list_template', data);
	$loadMore.replaceWith(htmlString);
}