$(function(){
	if(settings.debugMode === true){
		loadMineProfileData();
	}
});

function closeWebView(){
	WV.close("mineProfile", "");
}

function closeMineProfilePage(){
	refreshMinePageState();
	closeWebView();
}

var currentSP;
function hideSlidePanel(){
	if(currentSP == "CNSP"){
		hideChangeNameSP();
	}
	
	if(currentSP == "CISP"){
		hideChangeIntroduceSP();
	}
}

function loadMineProfileData(){
	getUserInfo();
	prepareAreaPickerData();
	
	bindChangeNameInputEvents();
	bindChangeIntroInputEvents();
	
	$("#loadingPanel").hide();
}

function getUserInfo(){
	var signState = getSignState();
	if(signState === true){
		var userId = getUserId();
		var requestUrl = "/users/" + userId + "/info";
		loadData("GET", requestUrl, "", true, function(status, response){
			if(status == 200){
				setUserProperty(response);
			}
		});
	}
}

function setUserProperty(data){
	$("#mp_nickname").text(data.Nickname);
	$("#mp_phone").text(data.PhoneNumber);
	
	var gender = parseInt(data.UserGender);
	if(gender > 0){
		$("#mp_gender").text(gender == 1 ? "男" : "女");
	}
	
	provinceCode = data.ProvinceCode == null ? 110000 : data.ProvinceCode;
	cityCode = data.CityCode == null ? 110100 : data.CityCode;
	countyCode = data.CountyCode == null ? 110101 : data.CountyCode;
	
	var province = data.ProvinceName;
	if(province){
		var city = data.CityName;
		var county = data.CountyName;
		
		var areaStr = getAreaStr(province, city, county);
		$("#mp_area").text(areaStr);
	}
	
	var intro = data.Introduce;
	if(intro){
		$("#mp_introduce").text(intro);
	}
}

function removeUserInfoCache(){
	var userId = getUserId();
	if(userId){
		var requestUrl = "/users/" + userId + "/info";
		removeAjaxCache("GET", requestUrl, "");
	}
}

function showChangeAvatarTip(){
	weui.alert("抱歉，暂不支持修改头像");
}

function showChangePhoneTip(){
	weui.alert("抱歉，暂不支持修改手机号");
}

function selectGender() {
	weui.picker([{
			label: "男",
			value: 1,
		},
		{
			label: "女",
			value: 2
		}
	], {
		className: "mp_section_picker",
		defaultValue: [1],
		onChange: function(result) {
			console.log(result[0].label)
		},
		onConfirm: function(result) {
			var userGender = result[0].value;
			var genderText = result[0].label;
			submitChangeGender(userGender, genderText);
		},
		id: 'selectGenderPicker'
	});
}

function submitChangeGender(userGender, genderText){
	var signState = getSignState();
	if(signState === true){
		var userId = getUserId();
		
		var requestUrl = "/mine/" + userId + "/gender/" + userGender;
		loadData("POST", requestUrl, "", false, function(status, response){
			if(status == 200 && response === true){
				$("#mp_gender").text(genderText);
				
				removeUserInfoCache();
			}
		});
	}
}

function getAreaStr(province, city, county){
	var areaStr;
	if(city && county){
		if(county == "NONE"){
			areaStr = province + " " + city;
		}else{
			areaStr = province + " " + city + " " + county;
		}
	}else if(city && !county){
		areaStr = province + " " + city;
	}else{
		areaStr = province;
	}
	
	return areaStr;
}

var pickerData;
function prepareAreaPickerData(){
	if(!pickerData){
		pickerData = new Array();
		
		var provinceList = DISTRICTS[100000];
		$.each(provinceList, function(i){
			var provinceObj = {};
			var provinceCode = i;
			var provinceName = provinceList[i];
			
			provinceObj['label'] = provinceName;
			provinceObj['value'] = provinceCode;
			provinceObj['children'] = new Array();
			
			var cityList = DISTRICTS[provinceCode];
			$.each(cityList, function(k){
				var cityObj = {};
				var cityCode = k;
				var cityName = cityList[k];
				
				cityObj['label'] = cityName;
				cityObj['value'] = cityCode;
				cityObj['children'] = new Array();
				
				provinceObj['children'].push(cityObj);
				
				var countyList = DISTRICTS[cityCode];
				$.each(countyList, function(t){
					var countyObj = {};
					var countyCode = t;
					var countyName = countyList[t];
					
					countyObj['label'] = countyName;
					countyObj['value'] = countyCode;
					
					cityObj['children'].push(countyObj);
				});
			});
		
			pickerData.push(provinceObj);
		});
	}
}

var provinceCode, cityCode, countyCode;
function selectArea(){
	weui.picker(pickerData, 
	{
		className: 'mp_section_picker',
		defaultValue: [provinceCode, cityCode, countyCode],
		onChange: function(result) {
			/*console.log(result[0].label);
			console.log(result[1].label);
			console.log(result[2].label);*/
		},
		onConfirm: function(result) {
			provinceCode = result[0].value;
			var provinceName = result[0].label;
			
			cityCode = result[1].value;
			var cityName = result[1].label;
			
			countyCode = "NONE";
			var countyName = "NONE";
			if(result[2]){
				countyCode = result[2].value;
				countyName = result[2].label;
			}
			
			submitChangeArea(provinceName, cityName, countyName);
		},
		id: 'selectAreaPicker'
	});
}

function submitChangeArea(provinceName, cityName, countyName){
	var signState = getSignState();
	if(signState === true){
		var userId = getUserId();
		
		var queryString = "provinceCode=" + provinceCode + "&cityCode=" + cityCode + "&countyCode=" +countyCode;
		var requestUrl = "/mine/" + userId + "/province/" + provinceName + "/city/" + cityName + "/county/" + countyName;
		loadData("POST", requestUrl, queryString, false, function(status, response){
			if(status == 200 && response === true){
				var areaStr = getAreaStr(provinceName, cityName, countyName);
				$("#mp_area").text(areaStr);
				
				removeUserInfoCache();
			}
		});
	}
}