template.helper('getProgress', function(courseId, mineCLList){
	var progress = 0;
	for (var i = 0; i < mineCLList.length; i++) {
		var item = mineCLList[i];
		if(item.CourseId == courseId){
			progress = item.LearningProgress;
			break;
		}
	}
	return progress;
});

template.helper('getLastLearningTime', function(courseId, mineCLList){
	var lastLearningTime = "未知";
	for (var i = 0; i < mineCLList.length; i++) {
		var item = mineCLList[i];
		if(item.CourseId == courseId){
			lastLearningTime = $.format.date(item.LastLearningTime, "yyyy-MM-dd HH:mm");
			break;
		}
	}
	return lastLearningTime;
});

$(function(){
	if(settings.debugMode === true){
		var testMSCId = "d4bc6258f638453498ba4d08345cefae";
		loadMineServiceClassData(testMSCId);
	}
});

function closeWebView(){
	closeMineServiceClassPage();
}

function closeMineServiceClassPage(){
	WV.close("mineServiceClass", "");
}

function loadMineServiceClassData(mscId){
	var userId = getUserId();
	if(userId){
		var requestUrl = "/mine/" + userId + "/classes/" + mscId + "/info";
		loadData("GET", requestUrl, "", false, function(status, response){
			if(status == 200){
				initialMSCPage(response);
			}
		});
	}
}

var mscId, classId;
function initialMSCPage(data){
	mscId = data.MSC.MSCId;
	classId = data.MSC.ServiceClassId;
	
	setMSCPropertyItem(data);
	
	var other = setInterval(function(){
		loadTapedCourseLearningList(mscId, classId);
		loadLiveLessonList(classId);
		
		$("#loadingPanel").hide();
		clearInterval(other);
	}, 200);
}

var mineCLList;
function loadTapedCourseLearningList(mscId, classId){
	var userId = getUserId();
	if(userId){
		var requestUrl = "/mine/" + userId + "/classes/" + mscId + "/taped/" + classId;
		loadData("GET", requestUrl, "", false, function(status, response){
			if(status == 200){
				mineCLList = response.MineCLList;
				
				renderBaseCourseLearningList(response);
				renderAdvancedCourseLearningList(response);
				
				setTapedCourseLearningProgress(response);
				setTapedCourseLearningState(response);
			}
			
			componentHandler.upgradeDom();
		});
	}
}

function renderBaseCourseLearningList(data){
	if(data && data.HasBaseTapedCourse === true){
		data["TCT"] = 1;
		var htmlStr = template('msc_Taped_template', data);
		$("#msc_base_panel").html(htmlStr);
	}else{
		$("#base_list_nothing").show();
	}
}

function renderAdvancedCourseLearningList(data){
	if(data && data.HasAdvancedTapedCourse === true){
		data["TCT"] = 2;
		var htmlStr = template('msc_Taped_template', data);
		$("#msc_advanced_panel").html(htmlStr);
	}else{
		$("#advanced_list_nothing").show();
	}
}

function setTapedCourseLearningProgress(data){
	var mclList = data.MineCLList;
	if(mclList){
		for(var i = 0; i < mclList.length; i++) {
			var item = mclList[i];
			setProgressBar(item.CourseId, item.LearningProgress);
		}
	}
}

function setProgressBar(courseId, progressValue){
	document.querySelector('#progress_' + courseId).addEventListener('mdl-componentupgraded', function() {
		this.MaterialProgress.setProgress(progressValue);
	});
}

var firstStartMap = {};
function setTapedCourseLearningState(data){
	var mclList = data.MineCLList;
	if(mclList){
		for (var i = 0; i < mclList.length; i++) {
			var item = mclList[i];
			
			var icon, name;
			firstStartMap[item.CourseId] = false;
			
			if(item.LearningProgress == 100){
				icon = "&#xE042;";
				name = "复习一遍";
			}else{
				icon = "&#xE192;";
				name = "继续学习";
			}
			
			$("#icon_" + item.CourseId).html(icon);
			$("#text_" + item.CourseId).html(name);
		}
	}
}

function loadLiveLessonList(classId){
	var userId = getUserId();
	if(userId){
		var requestUrl = "/mine/" + userId + "/classes/" + classId + "/live";
		loadData("GET", requestUrl, "", false, function(status, response){
			if(status == 200){				
				renderLiveLessonList(response);
			}
		});
	}
}

function renderLiveLessonList(data){
	if(data && data.LiveLessonList.length > 0){
		var htmlStr = template('msc_live_template', data);
		$("#msc_live_panel").html(htmlStr);
	}else{
		$("#live_list_nothing").show();
	}
}

function setMSCPropertyItem(data){
	var serviceName = data.ServiceInfo.ServiceName;
	var periodName = data.ServiceClass.ClassName;
	$("#msc_title").text(serviceName + " - " + periodName);
}

function openCourseLearningView2(courseId){
	var wvName = "courseLearning";
	var wvCL = WV.load(wvName);
	
	var continuePlay = false;
	for (var i = 0; i < mineCLList.length; i++) {
		var item = mineCLList[i];
		if(item.CourseId == courseId){
			continuePlay = true;
		}
	}
	
	if(continuePlay === true){
		wvCL.evalJS("loadCourseLearningData2('" + courseId + "', true, '" + mscId + "', '" + classId + "')");
	}else{
		wvCL.evalJS("loadCourseLearningData2('" + courseId + "', false, '" + mscId + "', '" + classId + "')");
	}
	
	var viewObj = window[wvName];
	wvCL.addEventListener("titleUpdate", function(e){
		setTimeout(function(){
			var animation = viewObj.ShowAnimation;
			wvCL.show(animation, WV.AnimationDuration, function() {
				WV.showedCB(wvName, "");
			});
		}, settings.openWebviewDelay);
	}, false);
}
