$(function(){
	bindEvents();
});

function bindEvents(){
	$("#exitBtn").on("click", function(){
		exit();
	});
	
	$('#cbNonWIFICanPlay').change(nonWIFINetworkCanPlay);
	$('#cbNonWIFICanDownload').change(nonWIFINetworkCanDownload);
	
	$('#cbEnableAjaxDataCache').change(enableAjaxDataCache);
}

function closeWebView(){
	WV.close("mineSettings", "");
}

function closeMineSettingsPage(){
	refreshMinePageState();
	closeWebView();
}

function initialMineSettings(){
	getNonWIFICheckBoxState();
}

function getNonWIFICheckBoxState(){
	getItem(settings.nonWIFINCPlayKey, function(value){
		if(value == null){
			
		}else{
			var $cbNWCP = $('#cbNonWIFICanPlay');
			if(value === true){
				$cbNWCP.attr("checked", true);
			}else{
				$cbNWCP.attr("checked", false);
			}
		}
	});
	
	getItem(settings.nonWIFINCDownKey, function(value){
		if(value == null){
			
		}else{
			var $cbNWCD = $('#cbNonWIFICanDownload');
			if(value === true){
				$cbNWCD.attr("checked", true);
			}else{
				$cbNWCD.attr("checked", false);
			}
		}
	});
	
	getItem(settings.enableAjaxDataCacheKey, function(value){
		if(value == null){
			
		}else{
			var $cbEADC = $('#cbEnableAjaxDataCache');
			if(value === true){
				$cbEADC.attr("checked", true);
			}else{
				$cbEADC.attr("checked", false);
			}
		}
	});
}

function nonWIFINetworkCanPlay(){
	var $this = $(this);
    if($this.is(":checked")) {
        weui.confirm('请慎重选择开启，避免过度使用流量', {
        	title: '',
        	buttons: [{
        		label: '取消操作',
        		type: 'default',
        		onClick: function() {
        			$this.attr("checked", false);
        		}
        	}, {
        		label: '确认启用',
        		type: 'primary',
        		onClick: function() {
        			$this.attr("checked", true);
        			lfSetItem(settings.nonWIFINCPlayKey, true);
        		}
        	}]
        });
    }else{
    	$this.attr("checked", false);
    	lfSetItem(settings.nonWIFINCPlayKey, false);
    }
}

function nonWIFINetworkCanDownload(){
	var $this = $(this);
    if($this.is(":checked")) {
        weui.confirm('请慎重选择开启，避免过度使用流量', {
        	title: '',
        	buttons: [{
        		label: '取消操作',
        		type: 'default',
        		onClick: function() {
        			$this.attr("checked", false);
        		}
        	}, {
        		label: '确认启用',
        		type: 'primary',
        		onClick: function() {
        			$this.attr("checked", true);
        			lfSetItem(settings.nonWIFINCDownKey, true);
        		}
        	}]
        });
    }else{
    	$this.attr("checked", false);
    	lfSetItem(settings.nonWIFINCDownKey, false);
    }
}

function enableAjaxDataCache(){
	var $this = $(this);
    if($this.is(":checked")) {
        $this.attr("checked", true);
        lfSetItem(settings.enableAjaxDataCacheKey, true);
    }else{
    	$this.attr("checked", false);
    	lfSetItem(settings.enableAjaxDataCacheKey, false);
    }
}

function exit(){
	weui.confirm('真的要退出吗？', {
    	title: '',
    	buttons: [{
    		label: '取消',
    		type: 'default',
    		onClick: function() {
    			
    		}
    	}, {
    		label: '确定',
    		type: 'primary',
    		onClick: function() {
    			var userId = getUserId();
				var requestUrl = "/users/" + userId + "/exit";
				loadData("POST", requestUrl, "", false, function(status, response){
					if(status == 200){
						SCRemoveItem(settings.tokenKey);
						closeMineSettingsPage();
					}
				});
    		}
    	}]
    });
}