template.helper('classDateFormat', function(dateTime){
	return $.format.date(dateTime, "yyyy.MM.dd");
});

template.helper('getAvatarUrl', function(avatarUrl){
	if(startWith(avatarUrl, "http")){
		return avatarUrl;
	}else{
		avatarUrl = avatarUrl.substring(3, avatarUrl.length);
		console.log(avatarUrl);
		return avatarUrl;
	}
});

function initialServicePage(data, fromCache){
	renderServiceList(data);
	
	bindTeacherItemClickEvent();
    $("#loadingPanel").hide();
}

function renderServiceList(data){
	if(data && data.ClassList){
		var htmlString = template('serviceListTemplate', data);
		$("#serviceListPanel").html(htmlString);
	}else{
		$(".list_nothing").show();
	}	
}

function bindTeacherItemClickEvent(){
	$(".teacher_list").on("click", ".item", function(e){
		var teacherId = $(this).attr("id");
		if(teacherId){
			openTeacherInfoView(teacherId);
		}
		
		e.stopPropagation();
	});
}

function openTeacherInfoView(teacherId){
	var wvTeacher = WV.load("teacher");
	wvTeacher.evalJS("loadTeacherData('" + teacherId + "')");
	
	var viewObj = window["teacher"];
	wvTeacher.addEventListener("titleUpdate", function(e){
		setTimeout(function(){
			var animation = viewObj.ShowAnimation;
			wvTeacher.show(animation, WV.AnimationDuration, function() {
				WV.showedCB("teacher", "");
			});
		}, settings.openWebviewDelay);
	}, false);
}