$(function(){
	FastClick.attach(document.body);
	
	if(settings.debugMode === false){
		var testTeacherId = "T01";
		loadTeacherData(testTeacherId);
	}
});

function closeWebView(){
	closeTeacherPage();
}

function closeTeacherPage(){
	WV.close("teacher", "");
}

var _teacherId;
function loadTeacherData(teacherId){
	_teacherId = teacherId;
	
	var requestUrl = "/teachers/" + teacherId + "/info";
	var queryString = "teacherId=" + teacherId;
	loadData("GET", requestUrl, queryString, false, function(status, response){
		if(status == 200){
			initialTeacherPage(response);
		}
	});
}

var defaultImg = "../image/course-nothing.jpg";
function initialTeacherPage(data){
	renderTeacherInfo(data);
	getCourseList();
	
	loadImg(defaultImg);
	bindCourseItemClickEvent
	
	$("#loadingPanel").hide();
}

function renderTeacherInfo(data){
	var htmlStr = template('teacher_info_template', data);
	$("#teacher_info_panel").html(htmlStr);
}

function getCourseList(){
	var requestUrl = "/teachers/" + _teacherId + "/courses";
	var queryString = "teacherId=" + _teacherId;
	loadData("GET", requestUrl, queryString, false, function(status, response){
		if(status == 200){
			renderCourseList(response);
		}
	});
}

var flag = false;
function bindCourseItemClickEvent(){
	$(document).on('tap', '.course-item', function() {
		if(!flag){
			flag = true;
			setTimeout(function(){ flag = false; }, 500);
			
			var $this = $(this);
			var courseId = $this.attr("courseId");
			if(courseId){
				var free = $(this).attr("free");
		        if(free == 1){
		        	openCoursePreviewFreeView(courseId, true);
		        }else{
		        	openCoursePreviewView(courseId, true);
		        }
			}
		}
		
		return false;
    });
}

function renderCourseList(data){
	var htmlStr = template('course_list_template', data);
	$("#course_list_panel").html(htmlStr);
}
